#include <tfslib.h>
#include <stdlib.h>
#include <string.h>
#include <stdio.h>
#include <unistd.h>

#include "config.h"

void help ()
{
  printf ("Dump all blocks\n");
  printf ("Usage: [args]\n");
  printf ("-d device\tuse USB device\n");
  printf ("-h\thelp\n");
  exit (0);
}

int main (int argc, char **argv)
{
  u32 i;
  u16 c;
  u8 nb;
  u16 pos;
  u8 buf[1000];
  u8 len;
  int result;
  u8 sort;
  u16 j;
  u8 *d_name;
  u8 path[1000] = { '/', '\0' };
  u8 name[1000];
  u16 name_end;
  u16 path_end;
  b32 f;
  u8 dump = 0;
  Inode ino;
  u8 off;
  u32 page;
  u8 *dev = USBDEVICE;

  do
  {
    result = getopt (argc, argv, "hd:");
    switch (result)
    {
      case 'd':
	dev = optarg;
	break;
      case 'h':
	help ();
	break;
    }
  }
  while (result > 0);

  init_mc (dev);

  off = 1;
  if (mc_blocks () == 4)
    off = 2;

  for (page = 0; page < mc_pages (); page++)
  {
    printf ("PAGE %04X ", page);

    dataFlashMemoryToBufferRead (0, page);
    dataFlashBufferRead (0, buf, 262, 2);
    printf ("%02X%02X ", buf[1], buf[0]);
    dataFlashBufferRead (0, buf, mc_blocks () * 264 - 4, 4);
    printf ("%02X%02X%02X%02X ", buf[0], buf[1], buf[2], buf[3]);
    printf ("\n");
  }

  close_mc ();
}
